/***************************************************************************//**
* @file     A31G11x_SystemClock.c
* @brief    Contains all functions support for Example Code on A31G11x
*
*
*
* @version  1.00
* @date     2020-05-29
* @author   ABOV Application Team
*
* Copyright(C) 2019, ABOV Semiconductor
* All rights reserved.
*
*//****************************************************************************/
/*******************************************************************************
 *                          A31G11x Device
 *------------------------------------------------------------------------
 *    System Clock source       | High Speend Internal oscillator
 *------------------------------------------------------------------------
 *    SYSCLK(MHz)               | 40MHz
 *------------------------------------------------------------------------
 *    HCLK(MHz) - Core Clock    | 40MHz
 *------------------------------------------------------------------------
 *    PCLK(MHz) - Peri Clock    | 40MHz
 *------------------------------------------------------------------------
 ******************************************************************************/

#include "main_conf.h"

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */


/* Private define ----------------------------------------------------------- */

// Main Clock Selection: Select only one of the following.
#define USED_HIRC       /*  HIRC  :  40000000uL */
//#define USED_WDTRC      /*  WDTRC :  40000uL */
//#define USED_XMOSC      /*  XMOSC :  16000000uL */
//#define USED_XSOSC      /*  XSOSC :  32768uL */

/* Clock Out Selection ( Monitoring ) */
/*#define USED_CLKO*/


/* Private function prototypes ---------------------------------------------- */

void SystemClock_Config( void );


/* Private variables -------------------------------------------------------- */


/*-------------------------------------------------------------------------*//**
 * @brief         Initialize default clock for A31G11x Board
 * @param         None
 * @return        None
 *//*-------------------------------------------------------------------------*/
void SystemClock_Config( void )
{
   SCUCG_SetHCLK( HDIV_MCLK4 );                                                // Core Clock 10MHz from here
   SystemCoreClockUpdate();
}

